# coding: utf-8

"""
    Artifacts API

     Artifacts is an API-based MMO game where you can manage 5 characters to explore, fight, gather resources, craft items and much more.  Website: https://artifactsmmo.com/  Documentation: https://docs.artifactsmmo.com/  OpenAPI Spec: https://api.artifactsmmo.com/openapi.json 

    The version of the OpenAPI document: 1.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from pyartifactsmmo.models.drop_rate_schema import DropRateSchema
from typing import Optional, Set
from typing_extensions import Self

class ResourceSchema(BaseModel):
    """
    ResourceSchema
    """ # noqa: E501
    name: StrictStr = Field(description="The name of the resource")
    code: StrictStr = Field(description="The code of the resource. This is the resource's unique identifier (ID).")
    skill: StrictStr = Field(description="The skill required to gather this resource.")
    level: StrictInt = Field(description="The skill level required to gather this resource.")
    drops: List[DropRateSchema] = Field(description="The drops of this resource.")
    __properties: ClassVar[List[str]] = ["name", "code", "skill", "level", "drops"]

    @field_validator('skill')
    def skill_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['mining', 'woodcutting', 'fishing']):
            raise ValueError("must be one of enum values ('mining', 'woodcutting', 'fishing')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ResourceSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in drops (list)
        _items = []
        if self.drops:
            for _item_drops in self.drops:
                if _item_drops:
                    _items.append(_item_drops.to_dict())
            _dict['drops'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ResourceSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "code": obj.get("code"),
            "skill": obj.get("skill"),
            "level": obj.get("level"),
            "drops": [DropRateSchema.from_dict(_item) for _item in obj["drops"]] if obj.get("drops") is not None else None
        })
        return _obj


